#
# spec file for package nv_glx (Version 1.0-1251)
# 
# Copyright  (c)  2001  SuSE GmbH  Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
# 
# please send bugfixes or comments to feedback@suse.de.
#

# neededforbuild lx_sus22
# usedforbuild    aaa_base aaa_dir autoconf automake base bash bindutil binutils bison bzip compress cpio cracklib db devs diffutils e2fsprogs file fileutils findutils flex gawk gcc gdbm gdbm-devel gettext glibc glibc-devel gpm gppshare groff gzip kbd less libtool libz lx_suse make mktemp modutils ncurses ncurses-devel net-tools netcfg nkitb pam pam-devel patch perl pgp ps rcs rpm sendmail sh-utils shadow strace syslogd sysvinit texinfo textutils timezone unzip util-linux vim xdevel xf86 xshared

%define __os_install_post %{nil}

Vendor:       NVIDIA Corp.
Distribution: SuSE Linux 7.1 (i386)
Name:         NVIDIA_GLX
Packager:     feedback@suse.de
Copyright:    NVIDIA Corp.
Group:        User Interface/X Hardware Support
Provides:     nv_glx libgl libMesaGL.so.3
Autoreqprov:  on
Version:      1.0
Release:      0
Source:       NVIDIA_kernel-1.0-1251.tar.gz    
Source1:      NVIDIA_GLX-1.0-1251.tar.gz
Source3:      LICENSE
Source4:      Makefile.module
Source5:      switch2nvidia_glx
Source6:      config.default.ikr
Source7:      config.smp.ikr
Source8:      config.default_24.ikr
Source9:      config.smp_24.ikr
Patch:        NVIDIA_kernel-1.0-1251.dif
URL:          http://www.nvidia.com
Buildroot:    /tmp/buildroot_nv_glx
Summary:      NVIDIA module for XFree86 4.0 X server and OpenGL libraries
Obsoletes:    nv_glx
#License:      NVIDIA Corp. 2000

%description -n NVIDIA_GLX
NVIDIA XFree86 4.0 server module and OpenGL 1.2 libraries for RIVA TNT/TNT2
and GeForce/Quadro based video cards.  Older RIVA 128 based video cards are
supported by the server module shipping with XFree86 4.0, nv_drv.o. You
should install this package if you have one of the newer cards.
 
You must also install the NVIDIA_kernel module if you want to utilize these
drivers.                      

%package -n NVIDIA_kernel
Group:        User Interface/X Hardware Support
Summary:      NVIDIA kernel module for NVIDIA Architecture support.

%description -n NVIDIA_kernel
NVIDIA Architecture support for Linux kernel 2.2.X/2.4.X

%prep
%setup -n NVIDIA_kernel-1.0-1251 -b1
%patch

%build

%install
rm -rf $RPM_BUILD_ROOT
( cd ../NVIDIA_GLX-1.0-1251
  mkdir -p $RPM_BUILD_ROOT/usr/X11R6/lib/modules/{drivers,extensions} \
           $RPM_BUILD_ROOT/usr/lib/
  install -m 755 -o root -g root usr/X11R6/lib/modules/drivers/nvidia_drv.o \
    $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/
  install -m 755 -o root -g root usr/X11R6/lib/modules/extensions/libglx.so.1.0.1251 \
    $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/
  install -m 755 -o root -g root usr/lib/libGLcore.so.1.0.1251 \
    $RPM_BUILD_ROOT/usr/lib/
  install -m 755 -o root -g root usr/lib/libGL.so.1.0.1251 \
    $RPM_BUILD_ROOT/usr/lib/
)
( cd $RPM_BUILD_ROOT/usr/lib
  mkdir -p GL
  mv libGL.so.1.0.1251 GL/libGL.so.1.0.1251.nv_glx
  mv libGLcore.so.1.0.1251 libGLcore.so.1.0.1251.nv_glx
)
( cd $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions
  mv libglx.so.1.0.1251 libglx.so.1.0.1251.nv_glx
)
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx/usr/include
install -m 644 -o root -g root $RPM_SOURCE_DIR/LICENSE\
  $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx
( cd ../NVIDIA_GLX-1.0-1251/usr/share/doc
  install -m 644 -o root -g root NVIDIA_Changelog README ALI_USERS_README \
    TNT_USERS_README TWINVIEW_README LAPTOP_README TVOUT_README XF86Config.sample \
    $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx
)
install -m 644 -o root -g root ../NVIDIA_GLX-1.0-1251/Makefile \
  $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx/
cp -r ../NVIDIA_GLX-1.0-1251/usr/include/GL \
  $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx/usr/include
chmod 644 $RPM_BUILD_ROOT/usr/share/doc/packages/nv_glx/usr/include/GL/*    
mkdir -p $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx
install -m 644 * $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx
install -m 644 $RPM_SOURCE_DIR/Makefile.module $RPM_SOURCE_DIR/README \
  $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/bin
cp ${RPM_SOURCE_DIR}/switch2nvidia_glx $RPM_BUILD_ROOT/usr/X11R6/bin
# Build kernel modules
cd /usr/src; rm -f linux; ln -s linux-2.4.0.SuSE linux
for i in  $RPM_SOURCE_DIR/config.default_24.ikr $RPM_SOURCE_DIR/config.smp_24.ikr; do
  cd /usr/src/linux
  cp $i .config
  make oldconfig 
  make dep
  if test "$i" = "$RPM_SOURCE_DIR/config.default_24.ikr"; then
    echo "Kernel 2.4.0-4GB"
    grep -v UTS_RELEASE include/linux/version.h > /tmp/version.h
    echo "#define UTS_RELEASE \"2.4.0-4GB\"" >  include/linux/version.h
    cat /tmp/version.h >> include/linux/version.h
  else
    echo "Kernel 2.4-64GB-SMP"
    grep -v UTS_RELEASE include/linux/version.h > /tmp/version.h
    echo "#define UTS_RELEASE \"2.4.0-64GB-SMP\"" >  include/linux/version.h
    cat /tmp/version.h >> include/linux/version.h
  fi
  cd $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx
  make clean
  make -f Makefile.module
  UTS_RELEASE=`grep UTS_RELEASE /usr/src/linux/include/linux/version.h|cut -d " " -f 3|sed s/\"//g`
  mkdir -p $RPM_BUILD_ROOT/lib/modules/$UTS_RELEASE/video
  install -m 644 -o root -g root NVdriver $RPM_BUILD_ROOT/lib/modules/$UTS_RELEASE/video
done
cd /usr/src; rm -f linux; ln -s linux-2.2.19.SuSE linux
for i in  $RPM_SOURCE_DIR/config.default.ikr $RPM_SOURCE_DIR/config.smp.ikr; do
  cd /usr/src/linux
  cp $i .config
  make oldconfig
  make dep
  if test "$i" = "$RPM_SOURCE_DIR/config.default.ikr"; then
    echo "Kernel 2.2.18"
    grep -v UTS_RELEASE include/linux/version.h > /tmp/version.h
    echo "#define UTS_RELEASE \"2.2.18\"" >  include/linux/version.h
    cat /tmp/version.h >> include/linux/version.h
  else
    echo "Kernel 2.2.18-SMP"
    grep -v UTS_RELEASE include/linux/version.h > /tmp/version.h
    echo "#define UTS_RELEASE \"2.2.18-SMP\"" >  include/linux/version.h
    cat /tmp/version.h >> include/linux/version.h
  fi
  cd $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx
  make clean
  make -f Makefile.module
  UTS_RELEASE=`grep UTS_RELEASE /usr/src/linux/include/linux/version.h|cut -d " " -f 3|sed s/\"//g`
  mkdir -p $RPM_BUILD_ROOT/lib/modules/$UTS_RELEASE/video
  install -m 644 -o root -g root NVdriver $RPM_BUILD_ROOT/lib/modules/$UTS_RELEASE/video
done
cd $RPM_BUILD_ROOT/usr/src/kernel-modules/nv_glx; make clean
rm -f *.orig  
%{?suse_check}

%post -n NVIDIA_GLX
rm -f usr/X11R6/bin/switch2nv_glx
usr/X11R6/bin/switch2nvidia_glx
exit 0

%preun -n NVIDIA_GLX
cp -a usr/X11R6/bin/switch2nvidia_glx usr/X11R6/bin/switch2nvidia_glx.tmp
exit 0

%postun -n NVIDIA_GLX
test -f usr/X11R6/bin/switch2nvidia_glx || \
  usr/X11R6/bin/switch2nvidia_glx.tmp -removelinks
rm -f usr/X11R6/bin/switch2nvidia_glx.tmp
exit 0

%post -n NVIDIA_kernel
sbin/depmod -a
exit 0                  

%files -n NVIDIA_GLX
/usr/share/doc/packages/nv_glx/
/usr/X11R6/lib/modules/drivers/nvidia_drv.o
/usr/X11R6/lib/modules/extensions/libglx.so.1.0.1251.nv_glx
/usr/lib/GL/libGL.so.1.0.1251.nv_glx
/usr/lib/libGLcore.so.1.0.1251.nv_glx
/usr/X11R6/bin/switch2nvidia_glx

%files -n NVIDIA_kernel
%dir /usr/src/kernel-modules
%dir /usr/src/kernel-modules/nv_glx
/usr/src/kernel-modules/nv_glx/*
/lib/modules/*/video/NVdriver       

